﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Runtime.InteropServices;
using System.Windows.Forms;
using Infragistics.Win.UltraWinTree;

namespace UltraTreeDepthTest
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            ultraTree1.ShowRootLines = true;
            RadioButtonCheckedChanged(radioButton1, EventArgs.Empty);
        }

        private readonly Node node0 = new Node("Node (no children)");

        private readonly Node node1 = new Node("Node (level 1)")
        {
            new Node("Node (level 2)")
            {
                new Node("Node (level 3)")
            }
        };

        private void RadioButtonCheckedChanged(object sender, EventArgs e)
        {
            ultraTree1.DataSource = radioButton1.Checked
                ? new Node("root") {node0, node1,}
                : new Node("root") {node1, node0,};
            ultraTree1.ExpandAll(ExpandAllType.Always);
        }
    }

    public class Node : BindingList<Node>
    {
        public Node(string text)
        {
            Text = text;
        }

        public string Text { get; private set; }

        public BindingList<Node> Children
        {
            get { return this; }
        }
    }
}